PAPI_enum_event(3)

NAME
PAPI_enum_event - Enumerate PAPI preset or native events.

SYNOPSIS

Detailed Description

C Interface:
    #include <papi.h>
    int PAPI_enum_event( int * EventCode, int modifier );

Given a preset or native event code, PAPI_enum_event replaces the event code with the next available event in either the preset or native table. The modifier argument affects which events are returned. For all platforms and event types, a value of PAPI_ENUM_ALL (zero) directs the function to return all possible events.
 For preset events, a TRUE (non-zero) value currently directs the function to return event codes only for PAPI preset events available on this platform. This may change in the future. For native events, the effect of the modifier argument is different on each platform. See the discussion below for platform-specific definitions.

Parameters
    *EventCode A defined preset or native event such as PAPI_TOT_INS.
    modifier Modifies the search logic. See below for full list. For native events, each platform behaves differently. See platform-specific documentation for details.

Return values
    PAPI_ENOEVNT The next requested PAPI preset or native event is not available on the underlying hardware.

Examples:

    // Scan for all supported native events on this platform
    printf( "Name\t\t\t       Code\t   Description\n" );
    do {
        retval = PAPI_get_event_info( i, &info );
        if ( retval == PAPI_OK ) {
        printf( "%-30s %#-10x\n%s\n", info.symbol, info.event_code, info.long_descr );
        }
    } while ( PAPI_enum_event( &i, PAPI_ENUM_ALL ) == PAPI_OK );

    @par Generic Modifiers

     The following values are implemented for preset events
    •   PAPI_ENUM_EVENTS -- Enumerate all (default)
    •   PAPI_ENUM_FIRST -- Enumerate first event (preset or native) preset/native chosen based on type of EventCode
    @par Native Modifiers
     The following values are implemented for native events
    •   PAPI_NTV_ENUM_UMASKS -- Given an event, iterate through possible umasks one at a time
    •   PAPI_NTV_ENUM_UMASK_COMBOS -- Given an event, iterate through all possible combinations of umasks. This is not implemented on libpfm4.
Preset Modifiers
    The following values are implemented for preset events
    •   PAPI_PRESET_ENUM_AVAIL -- enumerate only available presets
    •   PAPI_PRESET_ENUM_CPU -- enumerate CPU preset events
    •   PAPI_PRESET_ENUM_CPU_AVAIL -- enumerate available CPU preset events
    •   PAPI_PRESET_ENUM_FIRST_COMP -- enumerate first component preset event
See also
    PAPI
    PAPIF
     PAPI_enum_cmp_event
    PAPI_get_event_info
    PAPI_event_name_to_code
    PAPI_preset
    PAPI_native

Author
Generated automatically by Doxygen for PAPI from the source code.